<template>
  <div class="books container">
    <div class="books__header">
      <h1 class="books__header-title">Books</h1>
      <a class="waves-effect waves-light btn books__header-button" v-on:click="toBack()">
        <i class="material-icons right">arrow_back</i>
        To Back
      </a>
    </div>
    <form v-on:submit.prevent="formValidate()" novalidate class="books__form">
      <div class="row">
        <div class="col s12">
          <div class="input-field col s4">
            <input
              class="validate"
              type="text"
              name="name"
              id="name"
              v-model="bookEdit.name"
              v-on:blur="formValidate('nameError', bookEdit.name)"
              maxlength="50"
              required
            />
            <label for="name" v-bind:class="{ active: bookEdit.name }">Name</label>
            <span class="input-feedback error" v-if="form.nameError">Required</span>
          </div>
          <div class="input-field col s4">
            <input
              class="validate"
              type="text"
              name="author"
              id="author"
              v-model="bookEdit.author"
              v-on:blur="formValidate('authorError', bookEdit.author)"
              maxlength="80"
              required
            />
            <label for="author" v-bind:class="{ active: bookEdit.author }">Author</label>
            <span class="input-feedback error" v-if="form.authorError">Required</span>
          </div>
          <div class="input-field col s4">
            <input
              class="validate"
              type="tel"
              name="price"
              id="price"
              v-money="money"
              v-model="bookEdit.price"
              v-on:blur="formValidate('priceError', bookEdit.price)"
              maxlength="80"
              required
            />
            <label for="price">Price</label>
            <span class="input-feedback error" v-if="form.priceError">Required</span>
          </div>
        </div>
      </div>

      <button
        class="btn waves-effect waves-light center-align m-rl-20 books__form-button"
        type="submit"
      >
        <i class="material-icons left">check</i>
        {{buttonTitle}}
      </button>
    </form>
  </div>
</template>

<script>
import axios from "axios/dist/axios";
import materialize from "materialize-css/dist/js/materialize.min.js";
import { VMoney } from "v-money";
export default {
  name: "BookForm",
  props: ["book"],
  data: () => {
    return {
      bookEdit: {},
      money: {
        decimal: ",",
        thousands: ".",
        prefix: "R$ ",
        suffix: "",
        precision: 2,
        masked: false
      },
      form: {
        nameError: false,
        authorError: false,
        priceError: false
      },
      title: "",
      buttonTitle: ""
    };
  },
  directives: {
    money: VMoney
  },
  methods: {
    getBook(book) {
      axios({
        method: "get",
        url: `http://localhost:3000/books/${book}`
      })
        .then(response => {
          this.bookEdit = response.data;
          this.title = `Editing`;
        })
        .catch(e => {
          console.error(e);
        });
    },
    editBook() {
      axios({
        method: "put",
        url: `http://localhost:3000/books/${this.bookEdit.id}`,
        data: { ...this.bookEdit }
      })
        .then(() => {
          this.toBack();
        })
        .catch(e => {
          console.error(e);
        });
    },
    addBook() {
      axios({
        method: "post",
        url: "http://localhost:3000/books",
        data: { ...this.bookEdit }
      })
        .then(() => {
          this.toBack();
        })
        .catch(e => {
          console.error(e);
        });
    },
    formValidate(blurValidate, field) {
      if (!blurValidate) {
        this.form.nameError = this.bookEdit.name ? false : true;
        this.form.authorError = this.bookEdit.author ? false : true;
        this.form.priceError = this.bookEdit.price ? false : true;
      } else {
        this.form[blurValidate] = field ? false : true;
      }

      if (
        !this.form.nameError &&
        !this.form.authorError &&
        !this.form.priceError &&
        !blurValidate
      ) {
        this.submit();
      }
    },
    submit() {
      if (this.book) {
        this.editBook();
      } else {
        this.addBook();
      }
    },
    toBack() {
      this.$router.push({ path: "/" });
    }
  },
  created() {
    this.buttonTitle = "Save";
    if (this.book) {
      this.getBook(this.book);
    } else {
      this.title = `Add new Book`;
    }
  }
};
</script>

<style scoped>
.books__header {
  display: flex;
  justify-content: space-between;
  align-items: center;
  background: #0b2950;
  margin-top: 20px;
  padding: 20px;
}
.books__header-title {
  display: inline-block;
  color: #fff;
  padding: 0;
  margin: 0;
}
.books__header-button {
  background: #e71455;
}
.books__table {
  background: #fff;
  padding: 20px;
}
.books__form {
  background: #fff;
  padding: 20px 0;
}
.books__form-button {
  background: #0b2950;
  margin: 30px auto 20px;
  display: block;
  height: 50px;
}
</style>
